#ifndef __PRINTCE_H__
#define __PRINTCE_H__


#ifndef PD_SELECTPORTRAIT

typedef UINT (APIENTRY *LPPRINTHOOKPROC) (HWND, UINT, WPARAM, LPARAM);
typedef struct tagPD  {
   DWORD            cbStruct;
   HWND             hwndOwner;
   HDC              hdc;
   DWORD            dwFlags;
   RECT             rcMinMargin;
   RECT             rcMargin;
   HINSTANCE        hinst;
   LPARAM           lCustData;
   LPPRINTHOOKPROC  pfnPrintHook;
   LPCTSTR          pszPrintTemplateName;
   HGLOBAL          hglbPrintTemplateResource;
} PRINTDLG , *LPPRINTDLG ;
BOOL  APIENTRY     PrintDlg (LPPRINTDLG);

// Out only
#define PD_SELECTALLPAGES                 0x00000001
#define PD_SELECTSELECTION                0x00000002
#define PD_SELECTDRAFTMODE                0x00000008
#define PD_SELECTA4                       0x00000010
#define PD_SELECTLETTER                   0x00000020
#define PD_SELECTINFRARED                 0x00000040 
#define PD_SELECTSERIAL                   0x00000080
// In only
#define PD_DISABLEPAPERSIZE               0x00000100
#define PD_DISABLEPRINTRANGE              0x00000200
#define PD_DISABLEMARGINS                 0x00000400
#define PD_DISABLEORIENTATION             0x00000800
#define PD_RETURNDEFAULTDC                0x00002000
#define PD_ENABLEPRINTHOOK                0x00004000 // not supported
#define PD_ENABLEPRINTTEMPLATE            0x00008000 // not supported
#define PD_ENABLEPRINTTEMPLATEHANDLE      0x00010000 // not supported
#define PD_TITLE                          0x00020000 // not supported
// In-Out
#define PD_SELECTPORTRAIT                 0x00040000
#define PD_SELECTLANDSCAPE                0x00080000
#define PD_MARGINS                        0x00100000
#define PD_INTHOUSANDTHSOFINCHES          0x00200000
#define PD_INHUNDREDTHSOFMILLIMETERS      0x00400000
#define PD_MINMARGINS                     0x00800000 // not supported

#endif // PD_SELECTPORTRAIT

#ifndef PSD_DEFAULTMINMARGINS
typedef struct tagDEVNAMES {
   WORD wDriverOffset;
   WORD wDeviceOffset;
   WORD wOutputOffset;
   WORD wDefault;
} DEVNAMES;

typedef DEVNAMES * LPDEVNAMES;

#define DN_DEFAULTPRN      0x0001

DWORD APIENTRY     CommDlgExtendedError(VOID);

typedef UINT (APIENTRY* LPPAGEPAINTHOOK)( HWND, UINT, WPARAM, LPARAM );
typedef UINT (APIENTRY* LPPAGESETUPHOOK)( HWND, UINT, WPARAM, LPARAM );

typedef struct tagPSDA
{
    DWORD           lStructSize;
    HWND            hwndOwner;
    HGLOBAL         hDevMode;
    HGLOBAL         hDevNames;
    DWORD           Flags;
    POINT           ptPaperSize;
    RECT            rtMinMargin;
    RECT            rtMargin;
    HINSTANCE       hInstance;
    LPARAM          lCustData;
    LPPAGESETUPHOOK lpfnPageSetupHook;
    LPPAGEPAINTHOOK lpfnPagePaintHook;
    LPCSTR          lpPageSetupTemplateName;
    HGLOBAL         hPageSetupTemplate;
} PAGESETUPDLGA, * LPPAGESETUPDLGA;

typedef struct tagPSDW
{
    DWORD           lStructSize;
    HWND            hwndOwner;
    HGLOBAL         hDevMode;
    HGLOBAL         hDevNames;
    DWORD           Flags;
    POINT           ptPaperSize; // ignored in CE
    RECT            rtMinMargin;
    RECT            rtMargin;
    HINSTANCE       hInstance;
    LPARAM          lCustData;
    LPPAGESETUPHOOK lpfnPageSetupHook;
    LPPAGEPAINTHOOK lpfnPagePaintHook; // ignored in CE
    LPCWSTR         lpPageSetupTemplateName;
    HGLOBAL         hPageSetupTemplate;
} PAGESETUPDLGW, * LPPAGESETUPDLGW;

#ifdef UNICODE
typedef PAGESETUPDLGW PAGESETUPDLG;
typedef LPPAGESETUPDLGW LPPAGESETUPDLG;
#else
typedef PAGESETUPDLGA PAGESETUPDLG;
typedef LPPAGESETUPDLGA LPPAGESETUPDLG;
#endif // UNICODE

BOOL APIENTRY PageSetupDlgA( LPPAGESETUPDLGA );
BOOL APIENTRY PageSetupDlgW( LPPAGESETUPDLGW );
#ifdef UNICODE
#define PageSetupDlg  PageSetupDlgW
#else
#define PageSetupDlg  PageSetupDlgA
#endif // UNICODE

#define PSD_DEFAULTMINMARGINS             0x00000000 // not supported
#define PSD_INWININIINTLMEASURE           0x00000000 // not supported
#define PSD_MINMARGINS                    0x00000001 // not supported
#define PSD_MARGINS                       0x00000002
#define PSD_INTHOUSANDTHSOFINCHES         0x00000004
#define PSD_INHUNDREDTHSOFMILLIMETERS     0x00000008
#define PSD_DISABLEMARGINS                0x00000010
#define PSD_DISABLEPRINTER                0x00000020
#define PSD_NOWARNING                     0x00000080 // not supported
#define PSD_DISABLEORIENTATION            0x00000100
#define PSD_DISABLEPAPER                  0x00000200
#define PSD_RETURNDEFAULT                 0x00000400
#define PSD_SHOWHELP                      0x00000800 // not supported
#define PSD_ENABLEPAGESETUPHOOK           0x00002000 // not supported
#define PSD_ENABLEPAGESETUPTEMPLATE       0x00008000 // not supported
#define PSD_ENABLEPAGESETUPTEMPLATEHANDLE 0x00020000 // not supported
#define PSD_ENABLEPAGEPAINTHOOK           0x00040000 // not supported
#define PSD_DISABLEPAGEPAINTING           0x00080000 // not supported
#define PSD_NONETWORKBUTTON               0x00200000 // not supported
#define PSD_DISABLEPRINTRANGE             0x10000000
#define PSD_RANGESELECTION                0x20000000

#endif // PSD_DEFAULTMINMARGINS

#ifndef SP_ERROR
#define SP_ERROR                          (-1)

#ifdef STRICT
typedef BOOL (CALLBACK* ABORTPROC)(HDC, int);
#else
typedef FARPROC ABORTPROC;
#endif //STRICT

typedef struct _DOCINFOA {
    int     cbSize;
    LPCSTR   lpszDocName;
    LPCSTR   lpszOutput;
    LPCSTR   lpszDatatype;
    DWORD    fwType;
} DOCINFOA, *LPDOCINFOA;

typedef struct _DOCINFOW {
    int     cbSize;
    LPCWSTR  lpszDocName;
    LPCWSTR  lpszOutput;
    LPCWSTR  lpszDatatype;
    DWORD    fwType;
} DOCINFOW, *LPDOCINFOW;

#ifdef UNICODE
typedef DOCINFOW DOCINFO;
typedef LPDOCINFOW LPDOCINFO;
#else
typedef DOCINFOA DOCINFO;
typedef LPDOCINFOA LPDOCINFO;
#endif // UNICODE
#endif // SP_ERROR

typedef struct _PRN_INFO {
	int		printer;
	int		port;
	int		paper;
	SIZE	paper_size;
	int		color_mode;
	BOOL	portrait;
	BOOL	draft_mode;
	RECT	user_margins;
	int		start_page;
	int		end_page;
} PRN_INFO;

// these defines used with PDC_GETSTATE
#define PRINT_STATE_PREPARE_PRINTING		0
#define PRINT_STATE_ESTABLISH_CONNECTION	1
#define PRINT_STATE_CONNECTED				2
#define PRINT_STATE_DISCONNECTED			3
#define PRINT_STATE_LOST_CONNECTION			4
#define PRINT_STATE_CLOSING_CONNECTION		5

// PDC API
typedef void 		(*FnpdcInit)(LPTSTR);
typedef void 		(*FnpdcUnInit)();
typedef BOOL 		(*FnpdcPageSetupDlg)(LPPAGESETUPDLG);
typedef BOOL 		(*FnpdcPrintDlg)(LPPRINTDLG);
typedef BOOL 		(*FnpdcSilentPrintSetup)(HWND,PRN_INFO *);
typedef void 		(*FnpdcGetCurrentSetup)(PRN_INFO *);
typedef int 		(*FnpdcGetState)();
typedef int 		(*FnpdcIsConnection)();
typedef int			(*FnpdcStartDoc)(HDC,const DOCINFO *);
typedef int			(*FnpdcEndDoc)(HDC);
typedef int			(*FnpdcStartPage)(HDC);
typedef int			(*FnpdcEndPage)(HDC);
typedef HDC			(*FnpdcGetPrinterDC)();
typedef BOOL		(*FnpdcBitBlt)(HDC,int,int,int,int,HDC,int,int,DWORD);
typedef BOOL		(*FnpdcStretchBlt)(HDC,int,int,int,int,HDC,int,int,int,int,DWORD);
typedef HGDIOBJ		(*FnpdcSelectObject)(HDC,HGDIOBJ);
typedef HDC			(*FnpdcCreateCompatibleDC)(HDC);
typedef int			(*FnpdcGetDeviceCaps)(HDC,int);
typedef BOOL		(*FnpdcDeleteDC)(HDC);
typedef int			(*FnpdcDrawText)(HDC,LPCTSTR,int,LPRECT,UINT);
typedef int			(*FnpdcDrawTextFlow)(HDC,LPCTSTR,LPRECT,UINT);
typedef int			(*FnpdcGetTextFlowHeight)(HDC,LPCTSTR,int,UINT);
typedef BOOL		(*FnpdcExtTextOut)(HDC,int,int,UINT,const RECT *,LPCTSTR,UINT,const int *);
typedef BOOL		(*FnpdcGetTextExtentPoint)(HDC,LPCTSTR,int,LPSIZE);
typedef BOOL		(*FnpdcGetTextExtentExPoint)(HDC,LPCTSTR,int,int,LPINT,LPINT,LPSIZE);
typedef BOOL		(*FnpdcGetTextMetrics)(HDC,LPTEXTMETRIC);
typedef COLORREF	(*FnpdcSetTextColor)(HDC,COLORREF);
typedef COLORREF	(*FnpdcSetBkColor)(HDC,COLORREF);
typedef int			(*FnpdcSetBkMode)(HDC,int);
typedef int			(*FnpdcSetROP2)(HDC,int);
typedef BOOL		(*FnpdcEllipse)(HDC,int,int,int,int);
typedef BOOL		(*FnpdcDrawLine)(HDC,int,int,int,int);
typedef BOOL		(*FnpdcPolyline)(HDC,const POINT *,int);
typedef BOOL		(*FnpdcRectangle)(HDC,int,int,int,int);
typedef BOOL		(*FnpdcRoundRect)(HDC,int,int,int,int,int,int);
typedef int			(*FnpdcGetVersion)();
typedef int			(*FnpdcSetAbortProc)(HDC,ABORTPROC);
typedef void		(*FnpdcSetSilentMode)(BOOL);
typedef int			(*FnpdcGetSentBytes)();
typedef void		(*FnpdcSetPDFFile)(LPCTSTR);
typedef void		(*FnpdcSetLanguage)(int);
typedef void		(*FnpdcSetPrnParam)(int,int);
typedef BOOL		(*FnpdcPolygon)(HDC,const POINT *,int);
typedef int			(*FnpdcIntersectClipRect)(HDC,int,int,int,int);
typedef void		(*FnpdcResetClipRect)(HDC);
typedef void		(*FnpdcPdfDashPolyline)(HDC,const POINT *,int,int,int,int);

typedef int			(*FnpdcDrawCodaBar)(HDC,LPCTSTR,int,int,BOOL,int);
typedef int			(*FnpdcDrawPostnet)(HDC,LPCTSTR,int,int,BOOL);
typedef int			(*FnpdcDrawCode39)(HDC,LPCTSTR,int,int,BOOL,BOOL,int);
typedef int			(*FnpdcDrawCode93)(HDC,LPCTSTR,int,int,BOOL,int);
typedef int			(*FnpdcDrawEAN13)(HDC,LPCTSTR,LPCTSTR,int,int,BOOL,int);
typedef int			(*FnpdcDrawEAN8)(HDC,LPCTSTR,LPCTSTR,int,int,BOOL,int);
typedef int			(*FnpdcDrawUPCA)(HDC,LPCTSTR,LPCTSTR,int,int,BOOL,int);
typedef int			(*FnpdcDrawUPCE)(HDC,LPCTSTR,LPCTSTR,int,int,BOOL,int);
typedef int			(*FnpdcDraw2OF5)(HDC,LPCTSTR,int,int,BOOL,BOOL,int);
typedef int			(*FnpdcDrawCode128)(HDC,LPCTSTR,int,int,BOOL,int);
typedef int			(*FnpdcDrawUCC128)(HDC,LPCTSTR,int,int,BOOL,int);
typedef int			(*FnpdcDrawMSI)(HDC,LPCTSTR,int,int,BOOL,int,int);
typedef int			(*FnpdcDrawPDF417)(HDC,LPCTSTR,int,int,int,int,BOOL,BOOL);
typedef void		(*FnpdcSetBarCodeHeight)(double);
typedef void		(*FnpdcSetBarCodeScale)(double);
typedef void		(*FnpdcSetBarCodeAngle)(int);
typedef void		(*FnpdcSetNetworkAddr)(LPCTSTR);
typedef void		(*FnpdcSetPdfPassword)(LPCTSTR);
typedef void		(*FnpdcSetPdfEncodeMode)(int);
typedef void		(*FnpdcSetPdfQuality)(int);
typedef void		(*FnpdcPdfTextToImage)(int, int, HDC, HFONT, LPCTSTR, SIZE *);
typedef void		(*FnpdcSetGamma)(double);
typedef BOOL		(*FnpdcSetPrinterDpi)(int, int, int);
typedef int			(*FnpdcGetPrinterDpi)(int, BOOL);

FnpdcInit					PDC_Init;
FnpdcUnInit					PDC_UnInit;
FnpdcPageSetupDlg			PDC_PageSetupDlg;
FnpdcPrintDlg				PDC_PrintDlg;
FnpdcSilentPrintSetup		PDC_SilentPrintSetup;
FnpdcGetCurrentSetup		PDC_GetCurrentSetup;
FnpdcGetState				PDC_GetState;
FnpdcIsConnection			PDC_IsConnection;
FnpdcStartDoc				PDC_StartDoc;
FnpdcEndDoc					PDC_EndDoc;
FnpdcStartPage				PDC_StartPage;
FnpdcEndPage				PDC_EndPage;
FnpdcGetPrinterDC			PDC_GetPrinterDC;
FnpdcBitBlt					PDC_BitBlt;
FnpdcStretchBlt				PDC_StretchBlt;
FnpdcSelectObject			PDC_SelectObject;
FnpdcCreateCompatibleDC		PDC_CreateCompatibleDC;
FnpdcGetDeviceCaps			PDC_GetDeviceCaps;
FnpdcDeleteDC				PDC_DeleteDC;
FnpdcDrawText				PDC_DrawText;
FnpdcDrawTextFlow			PDC_DrawTextFlow;
FnpdcGetTextFlowHeight		PDC_GetTextFlowHeight;
FnpdcExtTextOut				PDC_ExtTextOut;
FnpdcGetTextExtentPoint		PDC_GetTextExtentPoint;
FnpdcGetTextExtentExPoint	PDC_GetTextExtentExPoint;
FnpdcGetTextMetrics			PDC_GetTextMetrics;
FnpdcSetTextColor			PDC_SetTextColor;
FnpdcSetBkColor				PDC_SetBkColor;
FnpdcSetBkMode				PDC_SetBkMode;
FnpdcSetROP2				PDC_SetROP2;
FnpdcEllipse				PDC_Ellipse;
FnpdcDrawLine				PDC_DrawLine;
FnpdcPolyline				PDC_Polyline;
FnpdcRectangle				PDC_Rectangle;
FnpdcRoundRect				PDC_RoundRect;
FnpdcGetVersion				PDC_GetVersion;
FnpdcSetAbortProc			PDC_SetAbortProc;
FnpdcSetSilentMode			PDC_SetSilentMode;
FnpdcGetSentBytes			PDC_GetSentBytes;
FnpdcSetPDFFile				PDC_SetPDFFile;
FnpdcSetLanguage			PDC_SetLanguage;
FnpdcSetPrnParam			PDC_SetPrnParam;
FnpdcPolygon				PDC_Polygon;
FnpdcIntersectClipRect		PDC_IntersectClipRect;
FnpdcResetClipRect			PDC_ResetClipRect;
FnpdcPdfDashPolyline		PDC_PdfDashPolyline;

FnpdcDrawCodaBar			PDC_DrawCodaBar;
FnpdcDrawPostnet			PDC_DrawPostnet;
FnpdcDrawCode39				PDC_DrawCode39;
FnpdcDrawCode93				PDC_DrawCode93;
FnpdcDrawEAN13				PDC_DrawEAN13;
FnpdcDrawEAN8				PDC_DrawEAN8;
FnpdcDrawUPCA				PDC_DrawUPCA;
FnpdcDrawUPCE				PDC_DrawUPCE;
FnpdcDraw2OF5				PDC_Draw2OF5;
FnpdcDrawCode128			PDC_DrawCode128;
FnpdcDrawUCC128				PDC_DrawUCC128;
FnpdcDrawMSI				PDC_DrawMSI;
FnpdcDrawPDF417				PDC_DrawPDF417;
FnpdcSetBarCodeHeight		PDC_SetBarCodeHeight;
FnpdcSetBarCodeScale		PDC_SetBarCodeScale;
FnpdcSetBarCodeAngle		PDC_SetBarCodeAngle;
FnpdcSetNetworkAddr			PDC_SetNetworkAddr;
FnpdcSetPdfPassword			PDC_SetPdfPassword;
FnpdcSetPdfEncodeMode		PDC_SetPdfEncodeMode;
FnpdcSetPdfQuality			PDC_SetPdfQuality;
FnpdcPdfTextToImage			PDC_PdfTextToImage;
FnpdcSetGamma				PDC_SetGamma;
FnpdcSetPrinterDpi			PDC_SetPrinterDpi;
FnpdcGetPrinterDpi			PDC_GetPrinterDpi;

// Simple API

typedef enum
{
	kPixels = 0,
	kInches,
	kMillimeters,
	kCentimeters,
	kPoints
} MeasureUnit;

typedef enum
{
	hLeft = 0,
	hRight,
	hCenter
} TextHorAlign;

typedef enum
{
	vTop = 0,
	vBottom,
	vCenter
} TextVertAlign;

typedef void 		(*FnprnInit)(LPTSTR);
typedef void		(*FnprnUnInit)();
typedef BOOL		(*FnprnSetupDlg)(HWND);
typedef BOOL 		(*FnprnSilentPrintSetup)(HWND,PRN_INFO *);
typedef void 		(*FnprnGetCurrentSetup)(PRN_INFO *);
typedef int 		(*FnprnGetState)();
typedef int 		(*FnprnIsConnection)();
typedef int			(*FnprnStartDoc)();
typedef int			(*FnprnStartPage)();
typedef int			(*FnprnEndDoc)();
typedef void		(*FnprnDrawText)(LPCTSTR,double,double);
typedef int			(*FnprnDrawTextFlow)(LPCTSTR,double,double,double,double);
typedef double		(*FnprnGetTextFlowHeight)(LPCTSTR,double);
typedef void		(*FnprnDrawText2)(LPCTSTR,double,double,COLORREF);
typedef void		(*FnprnDrawAlignedText)(LPCTSTR,double,double,TextHorAlign,TextVertAlign);
typedef void		(*FnprnDrawEllipse)(double,double,double,double);
typedef void		(*FnprnDrawCircle)(double,double,double);
typedef void		(*FnprnDrawLine)(double,double,double,double);
typedef void		(*FnprnDrawRect)(double,double,double,double);
typedef void		(*FnprnDrawSolidRect)(double,double,double,double,COLORREF color);
typedef void		(*FnprnDrawRoundRect)(double,double,double,double,double,double);
typedef BOOL		(*FnprnDrawPicture)(TCHAR *,double,double,double,double,BOOL);
typedef BOOL		(*FnprnDrawBitmap)(HBITMAP,double,double,double,double,BOOL);
typedef BOOL		(*FnprnGetPictureSize)(TCHAR *,double *, double *);
typedef double		(*FnprnConvertValue)(double,MeasureUnit,MeasureUnit);
typedef void		(*FnprnSetMeasureUnit)(int);
typedef int			(*FnprnGetMeasureUnit)();
typedef void		(*FnprnSetLineWidth)(double);
typedef double		(*FnprnGetLineWidth)();
typedef void		(*FnprnSetLineColor)(COLORREF);
typedef COLORREF	(*FnprnGetLineColor)();
typedef void		(*FnprnSetFillColor)(COLORREF);
typedef COLORREF	(*FnprnGetFillColor)();
typedef void		(*FnprnSetFillStyle)(int);
typedef int			(*FnprnGetFillStyle)();
typedef void		(*FnprnSetTextColor)(COLORREF);
typedef COLORREF	(*FnprnGetTextColor)();
typedef void		(*FnprnSetFontName)(TCHAR *);
typedef TCHAR *		(*FnprnGetFontName)();
typedef void		(*FnprnSetFontSize)(double);
typedef void		(*FnprnSetFontSize2)(double,MeasureUnit);
typedef double		(*FnprnGetFontSize)();
typedef double		(*FnprnGetFontSize2)(MeasureUnit);
typedef void		(*FnprnSetFontBold)(BOOL);
typedef BOOL		(*FnprnGetFontBold)();
typedef void		(*FnprnSetFontItalic)(BOOL);
typedef BOOL		(*FnprnGetFontItalic)();
typedef void		(*FnprnSetFontStrike)(BOOL);
typedef BOOL		(*FnprnGetFontStrike)();
typedef void		(*FnprnSetFontUnderline)(BOOL);
typedef BOOL		(*FnprnGetFontUnderline)();
typedef double		(*FnprnGetTextHeight)(TCHAR *);
typedef double		(*FnprnGetTextWidth)(TCHAR *);
typedef double		(*FnprnGetPageHeight)();
typedef double		(*FnprnGetPageWidth)();
typedef double		(*FnprnGetLeftMargin)();
typedef void		(*FnprnSetLeftMargin)(double);
typedef double		(*FnprnGetRightMargin)();
typedef void		(*FnprnSetRightMargin)(double);
typedef double		(*FnprnGetTopMargin)();
typedef void		(*FnprnSetTopMargin)(double);
typedef double		(*FnprnGetBottomMargin)();
typedef void		(*FnprnSetBottomMargin)(double);
typedef int			(*FnprnGetVersion)();
typedef int			(*FnprnSetAbortProc)(ABORTPROC);
typedef void		(*FnprnSetSilentMode)(BOOL);
typedef int			(*FnprnGetSentBytes)();
typedef void		(*FnprnSetTransparentTextBgr)(BOOL);
typedef void		(*FnprnSetTextHorAlign)(TextHorAlign);
typedef void		(*FnprnSetTextVertAlign)(TextVertAlign);
typedef void		(*FnprnSetPDFFile)(LPCTSTR);
typedef void		(*FnprnSetLanguage)(int);
typedef void		(*FnprnSetPrnParam)(int,int);
typedef void		(*FnprnSetFontAngle)(int);
typedef int			(*FnprnGetFontAngle)();

typedef double		(*FnprnDrawCodaBar)(LPCTSTR,double,double,BOOL,int);
typedef double		(*FnprnDrawPostnet)(LPCTSTR,double,double,BOOL);
typedef double		(*FnprnDrawCode39)(LPCTSTR,double,double,BOOL,BOOL,int);
typedef double		(*FnprnDrawCode93)(LPCTSTR,double,double,BOOL,int);
typedef double		(*FnprnDrawEAN13)(LPCTSTR,LPCTSTR,double,double,BOOL,int);
typedef double		(*FnprnDrawEAN8)(LPCTSTR,LPCTSTR,double,double,BOOL,int);
typedef double		(*FnprnDrawUPCA)(LPCTSTR,LPCTSTR,double,double,BOOL,int);
typedef double		(*FnprnDrawUPCE)(LPCTSTR,LPCTSTR,double,double,BOOL,int);
typedef double		(*FnprnDraw2OF5)(LPCTSTR,double,double,BOOL,BOOL,int);
typedef double		(*FnprnDrawCode128)(LPCTSTR,double,double,BOOL,int);
typedef double		(*FnprnDrawUCC128)(LPCTSTR,double,double,BOOL,int);
typedef double		(*FnprnDrawMSI)(LPCTSTR,double,double,BOOL,int,int);
typedef double		(*FnprnDrawPDF417)(LPCTSTR,double,double,int,int,BOOL,BOOL);
typedef void		(*FnprnSetBarCodeHeight)(double);
typedef void		(*FnprnSetBarCodeScale)(double);
typedef void		(*FnprnSetBarCodeAngle)(int);
typedef void		(*FnprnSetNetworkAddr)(LPCTSTR);
typedef void		(*FnprnSetPdfPassword)(LPCTSTR);
typedef void		(*FnprnSetPdfEncodeMode)(int);
typedef void		(*FnprnSetPdfQuality)(int);
typedef void		(*FnprnSetGamma)(double);
typedef BOOL		(*FnprnSetPrinterDpi)(int, int, int);
typedef int			(*FnprnGetPrinterDpi)(int, BOOL);

FnprnInit				prnInit;
FnprnUnInit				prnUnInit;
FnprnSetupDlg			prnSetupDlg;
FnprnSilentPrintSetup	prnSilentPrintSetup;
FnprnGetCurrentSetup	prnGetCurrentSetup;
FnprnGetState			prnGetState;
FnprnIsConnection		prnIsConnection;
FnprnStartDoc			prnStartDoc;
FnprnStartPage			prnStartPage;
FnprnEndDoc				prnEndDoc;
FnprnDrawText			prnDrawText;
FnprnDrawTextFlow		prnDrawTextFlow;
FnprnGetTextFlowHeight	prnGetTextFlowHeight;
FnprnDrawText2			prnDrawText2;
FnprnDrawAlignedText	prnDrawAlignedText;
FnprnDrawEllipse		prnDrawEllipse;
FnprnDrawCircle			prnDrawCircle;
FnprnDrawLine			prnDrawLine;
FnprnDrawRect			prnDrawRect;
FnprnDrawSolidRect		prnDrawSolidRect;
FnprnDrawRoundRect		prnDrawRoundRect;
FnprnDrawPicture		prnDrawPicture;
FnprnDrawBitmap			prnDrawBitmap;
FnprnGetPictureSize		prnGetPictureSize;
FnprnConvertValue		prnConvertValue;
FnprnSetMeasureUnit		prnSetMeasureUnit;
FnprnGetMeasureUnit		prnGetMeasureUnit;
FnprnSetLineWidth		prnSetLineWidth;
FnprnGetLineWidth		prnGetLineWidth;
FnprnSetLineColor		prnSetLineColor;
FnprnGetLineColor		prnGetLineColor;
FnprnSetFillColor		prnSetFillColor;
FnprnGetFillColor		prnGetFillColor;
FnprnSetFillStyle		prnSetFillStyle;
FnprnGetFillStyle		prnGetFillStyle;
FnprnSetTextColor		prnSetTextColor;
FnprnGetTextColor		prnGetTextColor;
FnprnSetFontName		prnSetFontName;
FnprnGetFontName		prnGetFontName;
FnprnSetFontSize		prnSetFontSize;
FnprnSetFontSize2		prnSetFontSize2;
FnprnGetFontSize		prnGetFontSize;
FnprnGetFontSize2		prnGetFontSize2;
FnprnSetFontBold		prnSetFontBold;
FnprnGetFontBold		prnGetFontBold;
FnprnSetFontItalic		prnSetFontItalic;
FnprnGetFontItalic		prnGetFontItalic;
FnprnSetFontStrike		prnSetFontStrike;
FnprnGetFontStrike		prnGetFontStrike;
FnprnSetFontUnderline	prnSetFontUnderline;
FnprnGetFontUnderline	prnGetFontUnderline;
FnprnGetTextHeight		prnGetTextHeight;
FnprnGetTextWidth		prnGetTextWidth;
FnprnGetPageHeight		prnGetPageHeight;
FnprnGetPageWidth		prnGetPageWidth;
FnprnGetLeftMargin		prnGetLeftMargin;
FnprnSetLeftMargin		prnSetLeftMargin;
FnprnGetRightMargin		prnGetRightMargin;
FnprnSetRightMargin		prnSetRightMargin;
FnprnGetTopMargin		prnGetTopMargin;
FnprnSetTopMargin		prnSetTopMargin;
FnprnGetBottomMargin	prnGetBottomMargin;
FnprnSetBottomMargin	prnSetBottomMargin;
FnprnGetVersion			prnGetVersion;
FnprnSetAbortProc		prnSetAbortProc;
FnprnSetSilentMode		prnSetSilentMode;
FnprnGetSentBytes		prnGetSentBytes;
FnprnSetTransparentTextBgr prnSetTransparentTextBgr;
FnprnSetTextHorAlign	prnSetTextHorAlign;
FnprnSetTextVertAlign	prnSetTextVertAlign;
FnprnSetPDFFile			prnSetPDFFile;
FnprnSetLanguage		prnSetLanguage;
FnprnSetPrnParam		prnSetPrnParam;
FnprnSetFontAngle		prnSetFontAngle;
FnprnGetFontAngle		prnGetFontAngle;

FnprnDrawCodaBar		prnDrawCodaBar;
FnprnDrawPostnet		prnDrawPostnet;
FnprnDrawCode39			prnDrawCode39;
FnprnDrawCode93			prnDrawCode93;
FnprnDrawEAN13			prnDrawEAN13;
FnprnDrawEAN8			prnDrawEAN8;
FnprnDrawUPCA			prnDrawUPCA;
FnprnDrawUPCE			prnDrawUPCE;
FnprnDraw2OF5			prnDraw2OF5;
FnprnDrawCode128		prnDrawCode128;
FnprnDrawUCC128			prnDrawUCC128;
FnprnDrawMSI			prnDrawMSI;
FnprnDrawPDF417			prnDrawPDF417;
FnprnSetBarCodeHeight	prnSetBarCodeHeight;
FnprnSetBarCodeScale	prnSetBarCodeScale;
FnprnSetBarCodeAngle	prnSetBarCodeAngle;
FnprnSetNetworkAddr		prnSetNetworkAddr;
FnprnSetPdfPassword		prnSetPdfPassword;
FnprnSetPdfEncodeMode	prnSetPdfEncodeMode;
FnprnSetPdfQuality		prnSetPdfQuality;
FnprnSetGamma			prnSetGamma;
FnprnSetPrinterDpi		prnSetPrinterDpi;
FnprnGetPrinterDpi		prnGetPrinterDpi;

HINSTANCE	hPrintLib = NULL;
BOOL		gPrintLibLoaded = FALSE;

BOOL LoadPrintLib()
{
	if(gPrintLibLoaded)
		return TRUE;

	hPrintLib = LoadLibrary(_T("PrintCE.dll"));

	if(!hPrintLib)
		return FALSE;

	PDC_Init = (FnpdcInit) ::GetProcAddress(hPrintLib, _T("PDC_Init"));
	if(!PDC_Init)
		goto err_end;
	PDC_UnInit = (FnpdcUnInit) ::GetProcAddress(hPrintLib, _T("PDC_UnInit"));
	if(!PDC_UnInit)
		goto err_end;
	PDC_PageSetupDlg = (FnpdcPageSetupDlg) ::GetProcAddress(hPrintLib, _T("PDC_PageSetupDlg"));
	if(!PDC_PageSetupDlg)
		goto err_end;
	PDC_PrintDlg = (FnpdcPrintDlg) ::GetProcAddress(hPrintLib, _T("PDC_PrintDlg"));
	if(!PDC_PrintDlg)
		goto err_end;
	PDC_SilentPrintSetup = (FnpdcSilentPrintSetup) ::GetProcAddress(hPrintLib, _T("PDC_SilentPrintSetup"));
	if(!PDC_SilentPrintSetup)
		goto err_end;
	PDC_GetCurrentSetup = (FnpdcGetCurrentSetup) ::GetProcAddress(hPrintLib, _T("PDC_GetCurrentSetup"));
	if(!PDC_GetCurrentSetup)
		goto err_end;
	PDC_GetState = (FnpdcGetState) ::GetProcAddress(hPrintLib, _T("PDC_GetState"));
	if(!PDC_GetState)
		goto err_end;
	PDC_IsConnection = (FnpdcIsConnection) ::GetProcAddress(hPrintLib, _T("PDC_IsConnection"));
	if(!PDC_IsConnection)
		goto err_end;
	PDC_StartDoc = (FnpdcStartDoc) ::GetProcAddress(hPrintLib, _T("PDC_StartDoc"));
	if(!PDC_StartDoc)
		goto err_end;
	PDC_EndDoc = (FnpdcEndDoc) ::GetProcAddress(hPrintLib, _T("PDC_EndDoc"));
	if(!PDC_EndDoc)
		goto err_end;
	PDC_StartPage = (FnpdcStartPage) ::GetProcAddress(hPrintLib, _T("PDC_StartPage"));
	if(!PDC_StartPage)
		goto err_end;
	PDC_EndPage = (FnpdcEndPage) ::GetProcAddress(hPrintLib, _T("PDC_EndPage"));
	if(!PDC_EndPage)
		goto err_end;
	PDC_GetPrinterDC = (FnpdcGetPrinterDC) ::GetProcAddress(hPrintLib, _T("PDC_GetPrinterDC"));
	if(!PDC_GetPrinterDC)
		goto err_end;
	PDC_BitBlt = (FnpdcBitBlt) ::GetProcAddress(hPrintLib, _T("PDC_BitBlt"));
	if(!PDC_BitBlt)
		goto err_end;
	PDC_StretchBlt = (FnpdcStretchBlt) ::GetProcAddress(hPrintLib, _T("PDC_StretchBlt"));
	if(!PDC_StretchBlt)
		goto err_end;
	PDC_SelectObject = (FnpdcSelectObject) ::GetProcAddress(hPrintLib, _T("PDC_SelectObject"));
	if(!PDC_SelectObject)
		goto err_end;
	PDC_CreateCompatibleDC = (FnpdcCreateCompatibleDC) ::GetProcAddress(hPrintLib, _T("PDC_CreateCompatibleDC"));
	if(!PDC_CreateCompatibleDC)
		goto err_end;
	PDC_GetDeviceCaps = (FnpdcGetDeviceCaps) ::GetProcAddress(hPrintLib, _T("PDC_GetDeviceCaps"));
	if(!PDC_GetDeviceCaps)
		goto err_end;
	PDC_DeleteDC = (FnpdcDeleteDC) ::GetProcAddress(hPrintLib, _T("PDC_DeleteDC"));
	if(!PDC_DeleteDC)
		goto err_end;
	PDC_DrawText = (FnpdcDrawText) ::GetProcAddress(hPrintLib, _T("PDC_DrawText"));
	if(!PDC_DrawText)
		goto err_end;
	PDC_DrawTextFlow = (FnpdcDrawTextFlow) ::GetProcAddress(hPrintLib, _T("PDC_DrawTextFlow"));
	if(!PDC_DrawTextFlow)
		goto err_end;
	PDC_GetTextFlowHeight = (FnpdcGetTextFlowHeight) ::GetProcAddress(hPrintLib, _T("PDC_GetTextFlowHeight"));
	if(!PDC_GetTextFlowHeight)
		goto err_end;
	PDC_ExtTextOut = (FnpdcExtTextOut) ::GetProcAddress(hPrintLib, _T("PDC_ExtTextOut"));
	if(!PDC_ExtTextOut)
		goto err_end;
	PDC_GetTextExtentPoint = (FnpdcGetTextExtentPoint) ::GetProcAddress(hPrintLib, _T("PDC_GetTextExtentPoint"));
	if(!PDC_GetTextExtentPoint)
		goto err_end;
	PDC_GetTextExtentExPoint = (FnpdcGetTextExtentExPoint) ::GetProcAddress(hPrintLib, _T("PDC_GetTextExtentExPoint"));
	if(!PDC_GetTextExtentExPoint)
		goto err_end;
	PDC_GetTextMetrics = (FnpdcGetTextMetrics) ::GetProcAddress(hPrintLib, _T("PDC_GetTextMetrics"));
	if(!PDC_GetTextMetrics)
		goto err_end;
	PDC_SetTextColor = (FnpdcSetTextColor) ::GetProcAddress(hPrintLib, _T("PDC_SetTextColor"));
	if(!PDC_SetTextColor)
		goto err_end;
	PDC_SetBkColor = (FnpdcSetBkColor) ::GetProcAddress(hPrintLib, _T("PDC_SetBkColor"));
	if(!PDC_SetBkColor)
		goto err_end;
	PDC_SetBkMode = (FnpdcSetBkMode) ::GetProcAddress(hPrintLib, _T("PDC_SetBkMode"));
	if(!PDC_SetBkMode)
		goto err_end;
	PDC_SetROP2 = (FnpdcSetROP2) ::GetProcAddress(hPrintLib, _T("PDC_SetROP2"));
	if(!PDC_SetROP2)
		goto err_end;
	PDC_Ellipse = (FnpdcEllipse) ::GetProcAddress(hPrintLib, _T("PDC_Ellipse"));
	if(!PDC_Ellipse)
		goto err_end;
	PDC_DrawLine = (FnpdcDrawLine) ::GetProcAddress(hPrintLib, _T("PDC_DrawLine"));
	if(!PDC_DrawLine)
		goto err_end;
	PDC_Polyline = (FnpdcPolyline) ::GetProcAddress(hPrintLib, _T("PDC_Polyline"));
	if(!PDC_Polyline)
		goto err_end;
	PDC_Rectangle = (FnpdcRectangle) ::GetProcAddress(hPrintLib, _T("PDC_Rectangle"));
	if(!PDC_Rectangle)
		goto err_end;
	PDC_RoundRect = (FnpdcRoundRect) ::GetProcAddress(hPrintLib, _T("PDC_RoundRect"));
	if(!PDC_RoundRect)
		goto err_end;
	PDC_GetVersion = (FnpdcGetVersion) ::GetProcAddress(hPrintLib, _T("PDC_GetVersion"));
	if(!PDC_GetVersion)
		goto err_end;
	PDC_GetSentBytes = (FnpdcGetSentBytes) ::GetProcAddress(hPrintLib, _T("PDC_GetSentBytes"));
	if(!PDC_GetSentBytes)
		goto err_end;
	PDC_SetAbortProc = (FnpdcSetAbortProc) ::GetProcAddress(hPrintLib, _T("PDC_SetAbortProc"));
	if(!PDC_SetAbortProc)
		goto err_end;
	PDC_SetSilentMode = (FnpdcSetSilentMode) ::GetProcAddress(hPrintLib, _T("PDC_SetSilentMode"));
	if(!PDC_SetSilentMode)
		goto err_end;
	PDC_SetPDFFile = (FnpdcSetPDFFile) ::GetProcAddress(hPrintLib, _T("PDC_SetPDFFile"));
	if(!PDC_SetPDFFile)
		goto err_end;
	PDC_SetLanguage = (FnpdcSetLanguage) ::GetProcAddress(hPrintLib, _T("PDC_SetLanguage"));
	if(!PDC_SetLanguage)
		goto err_end;
	PDC_SetPrnParam = (FnpdcSetPrnParam) ::GetProcAddress(hPrintLib, _T("PDC_SetPrnParam"));
	if(!PDC_SetPrnParam)
		goto err_end;
	PDC_Polygon = (FnpdcPolygon) ::GetProcAddress(hPrintLib, _T("PDC_Polygon"));
	if(!PDC_Polygon)
		goto err_end;
	PDC_IntersectClipRect = (FnpdcIntersectClipRect) ::GetProcAddress(hPrintLib, _T("PDC_IntersectClipRect"));
	if(!PDC_IntersectClipRect)
		goto err_end;
	PDC_ResetClipRect = (FnpdcResetClipRect) ::GetProcAddress(hPrintLib, _T("PDC_ResetClipRect"));
	if(!PDC_ResetClipRect)
		goto err_end;
	PDC_PdfDashPolyline = (FnpdcPdfDashPolyline) ::GetProcAddress(hPrintLib, _T("PDC_PdfDashPolyline"));
	if(!PDC_PdfDashPolyline)
		goto err_end;

	PDC_DrawCodaBar = (FnpdcDrawCodaBar) ::GetProcAddress(hPrintLib, _T("PDC_DrawCodaBar"));
	if(!PDC_DrawCodaBar)
		goto err_end;
	PDC_DrawPostnet = (FnpdcDrawPostnet) ::GetProcAddress(hPrintLib, _T("PDC_DrawPostnet"));
	if(!PDC_DrawPostnet)
		goto err_end;
	PDC_DrawCode39 = (FnpdcDrawCode39) ::GetProcAddress(hPrintLib, _T("PDC_DrawCode39"));
	if(!PDC_DrawCode39)
		goto err_end;
	PDC_DrawCode93 = (FnpdcDrawCode93) ::GetProcAddress(hPrintLib, _T("PDC_DrawCode93"));
	if(!PDC_DrawCode93)
		goto err_end;
	PDC_DrawEAN13 = (FnpdcDrawEAN13) ::GetProcAddress(hPrintLib, _T("PDC_DrawEAN13"));
	if(!PDC_DrawEAN13)
		goto err_end;
	PDC_DrawEAN8 = (FnpdcDrawEAN8) ::GetProcAddress(hPrintLib, _T("PDC_DrawEAN8"));
	if(!PDC_DrawEAN8)
		goto err_end;
	PDC_DrawUPCA = (FnpdcDrawUPCA) ::GetProcAddress(hPrintLib, _T("PDC_DrawUPCA"));
	if(!PDC_DrawUPCA)
		goto err_end;
	PDC_DrawUPCE = (FnpdcDrawUPCE) ::GetProcAddress(hPrintLib, _T("PDC_DrawUPCE"));
	if(!PDC_DrawUPCE)
		goto err_end;
	PDC_Draw2OF5 = (FnpdcDraw2OF5) ::GetProcAddress(hPrintLib, _T("PDC_Draw2OF5"));
	if(!PDC_Draw2OF5)
		goto err_end;
	PDC_DrawCode128 = (FnpdcDrawCode128) ::GetProcAddress(hPrintLib, _T("PDC_DrawCode128"));
	if(!PDC_DrawCode128)
		goto err_end;
	PDC_DrawUCC128 = (FnpdcDrawUCC128) ::GetProcAddress(hPrintLib, _T("PDC_DrawUCC128"));
	if(!PDC_DrawUCC128)
		goto err_end;
	PDC_DrawMSI = (FnpdcDrawMSI) ::GetProcAddress(hPrintLib, _T("PDC_DrawMSI"));
	if(!PDC_DrawMSI)
		goto err_end;
	PDC_DrawPDF417 = (FnpdcDrawPDF417) ::GetProcAddress(hPrintLib, _T("PDC_DrawPDF417"));
	if(!PDC_DrawPDF417)
		goto err_end;
	PDC_SetBarCodeHeight = (FnpdcSetBarCodeHeight) ::GetProcAddress(hPrintLib, _T("PDC_SetBarCodeHeight"));
	if(!PDC_SetBarCodeHeight)
		goto err_end;
	PDC_SetBarCodeScale = (FnpdcSetBarCodeScale) ::GetProcAddress(hPrintLib, _T("PDC_SetBarCodeScale"));
	if(!PDC_SetBarCodeScale)
		goto err_end;
	PDC_SetBarCodeAngle = (FnpdcSetBarCodeAngle) ::GetProcAddress(hPrintLib, _T("PDC_SetBarCodeAngle"));
	if(!PDC_SetBarCodeAngle)
		goto err_end;
	PDC_SetNetworkAddr = (FnpdcSetNetworkAddr) ::GetProcAddress(hPrintLib, _T("PDC_SetNetworkAddr"));
	if(!PDC_SetNetworkAddr)
		goto err_end;
	PDC_SetPdfPassword = (FnpdcSetPdfPassword) ::GetProcAddress(hPrintLib, _T("PDC_SetPdfPassword"));
	if(!PDC_SetPdfPassword)
		goto err_end;
	PDC_SetPdfEncodeMode = (FnpdcSetPdfEncodeMode) ::GetProcAddress(hPrintLib, _T("PDC_SetPdfEncodeMode"));
	if(!PDC_SetPdfEncodeMode)
		goto err_end;
	PDC_SetPdfQuality = (FnpdcSetPdfQuality) ::GetProcAddress(hPrintLib, _T("PDC_SetPdfQuality"));
	if(!PDC_SetPdfQuality)
		goto err_end;
	PDC_PdfTextToImage = (FnpdcPdfTextToImage) ::GetProcAddress(hPrintLib, _T("PDC_PdfTextToImage"));
	if(!PDC_PdfTextToImage)
		goto err_end;
	PDC_SetGamma = (FnpdcSetGamma) ::GetProcAddress(hPrintLib, _T("PDC_SetGamma"));
	if(!PDC_SetGamma)
		goto err_end;
	PDC_SetPrinterDpi = (FnpdcSetPrinterDpi) ::GetProcAddress(hPrintLib, _T("PDC_SetPrinterDpi"));
	if(!PDC_SetPrinterDpi)
		goto err_end;
	PDC_GetPrinterDpi = (FnpdcGetPrinterDpi) ::GetProcAddress(hPrintLib, _T("PDC_GetPrinterDpi"));
	if(!PDC_GetPrinterDpi)
		goto err_end;

	prnInit = (FnprnInit) ::GetProcAddress(hPrintLib, _T("prnInit"));
	if(!prnInit)
		goto err_end;
	prnUnInit = (FnprnUnInit) ::GetProcAddress(hPrintLib, _T("prnUnInit"));
	if(!prnUnInit)
		goto err_end;
	prnSetupDlg = (FnprnSetupDlg) ::GetProcAddress(hPrintLib, _T("prnSetupDlg"));
	if(!prnSetupDlg)
		goto err_end;
	prnSilentPrintSetup = (FnprnSilentPrintSetup) ::GetProcAddress(hPrintLib, _T("prnSilentPrintSetup"));
	if(!prnSilentPrintSetup)
		goto err_end;
	prnGetCurrentSetup = (FnprnGetCurrentSetup) ::GetProcAddress(hPrintLib, _T("prnGetCurrentSetup"));
	if(!prnGetCurrentSetup)
		goto err_end;
	prnGetState = (FnprnGetState) ::GetProcAddress(hPrintLib, _T("prnGetState"));
	if(!prnGetState)
		goto err_end;
	prnIsConnection = (FnprnIsConnection) ::GetProcAddress(hPrintLib, _T("prnIsConnection"));
	if(!prnIsConnection)
		goto err_end;
	prnStartDoc = (FnprnStartDoc) ::GetProcAddress(hPrintLib, _T("prnStartDoc"));
	if(!prnStartDoc)
		goto err_end;
	prnStartPage = (FnprnStartPage) ::GetProcAddress(hPrintLib, _T("prnStartPage"));
	if(!prnStartPage)
		goto err_end;
	prnEndDoc = (FnprnEndDoc) ::GetProcAddress(hPrintLib, _T("prnEndDoc"));
	if(!prnEndDoc)
		goto err_end;
	prnDrawText = (FnprnDrawText) ::GetProcAddress(hPrintLib, _T("prnDrawText"));
	if(!prnDrawText)
		goto err_end;
	prnDrawTextFlow = (FnprnDrawTextFlow) ::GetProcAddress(hPrintLib, _T("prnDrawTextFlow"));
	if(!prnDrawTextFlow)
		goto err_end;
	prnGetTextFlowHeight = (FnprnGetTextFlowHeight) ::GetProcAddress(hPrintLib, _T("prnGetTextFlowHeight"));
	if(!prnGetTextFlowHeight)
		goto err_end;
	prnDrawText2 = (FnprnDrawText2) ::GetProcAddress(hPrintLib, _T("prnDrawText2"));
	if(!prnDrawText2)
		goto err_end;
	prnDrawAlignedText = (FnprnDrawAlignedText) ::GetProcAddress(hPrintLib, _T("prnDrawAlignedText"));
	if(!prnDrawAlignedText)
		goto err_end;
	prnDrawEllipse = (FnprnDrawEllipse) ::GetProcAddress(hPrintLib, _T("prnDrawEllipse"));
	if(!prnDrawEllipse)
		goto err_end;
	prnDrawCircle = (FnprnDrawCircle) ::GetProcAddress(hPrintLib, _T("prnDrawCircle"));
	if(!prnDrawCircle)
		goto err_end;
	prnDrawLine = (FnprnDrawLine) ::GetProcAddress(hPrintLib, _T("prnDrawLine"));
	if(!prnDrawLine)
		goto err_end;
	prnDrawRect = (FnprnDrawRect) ::GetProcAddress(hPrintLib, _T("prnDrawRect"));
	if(!prnDrawRect)
		goto err_end;
	prnDrawSolidRect = (FnprnDrawSolidRect) ::GetProcAddress(hPrintLib, _T("prnDrawSolidRect"));
	if(!prnDrawSolidRect)
		goto err_end;
	prnDrawRoundRect = (FnprnDrawRoundRect) ::GetProcAddress(hPrintLib, _T("prnDrawRoundRect"));
	if(!prnDrawRoundRect)
		goto err_end;
	prnDrawPicture = (FnprnDrawPicture) ::GetProcAddress(hPrintLib, _T("prnDrawPicture"));
	if(!prnDrawPicture)
		goto err_end;
	prnDrawBitmap = (FnprnDrawBitmap) ::GetProcAddress(hPrintLib, _T("prnDrawBitmap"));
	if(!prnDrawBitmap)
		goto err_end;
	prnGetPictureSize = (FnprnGetPictureSize) ::GetProcAddress(hPrintLib, _T("prnGetPictureSize"));
	if(!prnGetPictureSize)
		goto err_end;
	prnConvertValue = (FnprnConvertValue) ::GetProcAddress(hPrintLib, _T("prnConvertValue"));
	if(!prnConvertValue)
		goto err_end;
	prnSetMeasureUnit = (FnprnSetMeasureUnit) ::GetProcAddress(hPrintLib, _T("prnSetMeasureUnit"));
	if(!prnSetMeasureUnit)
		goto err_end;
	prnGetMeasureUnit = (FnprnGetMeasureUnit) ::GetProcAddress(hPrintLib, _T("prnGetMeasureUnit"));
	if(!prnGetMeasureUnit)
		goto err_end;
	prnSetLineWidth = (FnprnSetLineWidth) ::GetProcAddress(hPrintLib, _T("prnSetLineWidth"));
	if(!prnSetLineWidth)
		goto err_end;
	prnGetLineWidth = (FnprnGetLineWidth) ::GetProcAddress(hPrintLib, _T("prnGetLineWidth"));
	if(!prnGetLineWidth)
		goto err_end;
	prnSetLineColor = (FnprnSetLineColor) ::GetProcAddress(hPrintLib, _T("prnSetLineColor"));
	if(!prnSetLineColor)
		goto err_end;
	prnGetLineColor = (FnprnGetLineColor) ::GetProcAddress(hPrintLib, _T("prnGetLineColor"));
	if(!prnGetLineColor)
		goto err_end;
	prnSetFillColor = (FnprnSetFillColor) ::GetProcAddress(hPrintLib, _T("prnSetFillColor"));
	if(!prnSetFillColor)
		goto err_end;
	prnGetFillColor = (FnprnGetFillColor) ::GetProcAddress(hPrintLib, _T("prnGetFillColor"));
	if(!prnGetFillColor)
		goto err_end;
	prnSetFillStyle = (FnprnSetFillStyle) ::GetProcAddress(hPrintLib, _T("prnSetFillStyle"));
	if(!prnSetFillStyle)
		goto err_end;
	prnGetFillStyle = (FnprnGetFillStyle) ::GetProcAddress(hPrintLib, _T("prnGetFillStyle"));
	if(!prnGetFillStyle)
		goto err_end;
	prnSetTextColor = (FnprnSetTextColor) ::GetProcAddress(hPrintLib, _T("prnSetTextColor"));
	if(!prnSetTextColor)
		goto err_end;
	prnGetTextColor = (FnprnGetTextColor) ::GetProcAddress(hPrintLib, _T("prnGetTextColor"));
	if(!prnGetTextColor)
		goto err_end;
	prnSetFontName = (FnprnSetFontName) ::GetProcAddress(hPrintLib, _T("prnSetFontName"));
	if(!prnSetFontName)
		goto err_end;
	prnGetFontName = (FnprnGetFontName) ::GetProcAddress(hPrintLib, _T("prnGetFontName"));
	if(!prnGetFontName)
		goto err_end;
	prnSetFontSize = (FnprnSetFontSize) ::GetProcAddress(hPrintLib, _T("prnSetFontSize"));
	if(!prnSetFontSize)
		goto err_end;
	prnSetFontSize2 = (FnprnSetFontSize2) ::GetProcAddress(hPrintLib, _T("prnSetFontSize2"));
	if(!prnSetFontSize2)
		goto err_end;
	prnGetFontSize = (FnprnGetFontSize) ::GetProcAddress(hPrintLib, _T("prnGetFontSize"));
	if(!prnGetFontSize)
		goto err_end;
	prnGetFontSize2 = (FnprnGetFontSize2) ::GetProcAddress(hPrintLib, _T("prnGetFontSize2"));
	if(!prnGetFontSize2)
		goto err_end;
	prnSetFontBold = (FnprnSetFontBold) ::GetProcAddress(hPrintLib, _T("prnSetFontBold"));
	if(!prnSetFontBold)
		goto err_end;
	prnGetFontBold = (FnprnGetFontBold) ::GetProcAddress(hPrintLib, _T("prnGetFontBold"));
	if(!prnGetFontBold)
		goto err_end;
	prnSetFontItalic = (FnprnSetFontItalic) ::GetProcAddress(hPrintLib, _T("prnSetFontItalic"));
	if(!prnSetFontItalic)
		goto err_end;
	prnGetFontItalic = (FnprnGetFontItalic) ::GetProcAddress(hPrintLib, _T("prnGetFontItalic"));
	if(!prnGetFontItalic)
		goto err_end;
	prnSetFontStrike = (FnprnSetFontStrike) ::GetProcAddress(hPrintLib, _T("prnSetFontStrike"));
	if(!prnSetFontStrike)
		goto err_end;
	prnGetFontStrike = (FnprnGetFontStrike) ::GetProcAddress(hPrintLib, _T("prnGetFontStrike"));
	if(!prnGetFontStrike)
		goto err_end;
	prnSetFontUnderline = (FnprnSetFontUnderline) ::GetProcAddress(hPrintLib, _T("prnSetFontUnderline"));
	if(!prnSetFontUnderline)
		goto err_end;
	prnGetFontUnderline = (FnprnGetFontUnderline) ::GetProcAddress(hPrintLib, _T("prnGetFontUnderline"));
	if(!prnGetFontUnderline)
		goto err_end;
	prnGetTextHeight = (FnprnGetTextHeight) ::GetProcAddress(hPrintLib, _T("prnGetTextHeight"));
	if(!prnGetTextHeight)
		goto err_end;
	prnGetTextWidth = (FnprnGetTextWidth) ::GetProcAddress(hPrintLib, _T("prnGetTextWidth"));
	if(!prnGetTextWidth)
		goto err_end;
	prnGetPageHeight = (FnprnGetPageHeight) ::GetProcAddress(hPrintLib, _T("prnGetPageHeight"));
	if(!prnGetPageHeight)
		goto err_end;
	prnGetPageWidth = (FnprnGetPageWidth) ::GetProcAddress(hPrintLib, _T("prnGetPageWidth"));
	if(!prnGetPageWidth)
		goto err_end;
	prnGetLeftMargin = (FnprnGetLeftMargin) ::GetProcAddress(hPrintLib, _T("prnGetLeftMargin"));
	if(!prnGetLeftMargin)
		goto err_end;
	prnSetLeftMargin = (FnprnSetLeftMargin) ::GetProcAddress(hPrintLib, _T("prnSetLeftMargin"));
	if(!prnSetLeftMargin)
		goto err_end;
	prnGetRightMargin = (FnprnGetRightMargin) ::GetProcAddress(hPrintLib, _T("prnGetRightMargin"));
	if(!prnGetRightMargin)
		goto err_end;
	prnSetRightMargin = (FnprnSetRightMargin) ::GetProcAddress(hPrintLib, _T("prnSetRightMargin"));
	if(!prnSetRightMargin)
		goto err_end;
	prnGetTopMargin = (FnprnGetTopMargin) ::GetProcAddress(hPrintLib, _T("prnGetTopMargin"));
	if(!prnGetTopMargin)
		goto err_end;
	prnSetTopMargin = (FnprnSetTopMargin) ::GetProcAddress(hPrintLib, _T("prnSetTopMargin"));
	if(!prnSetTopMargin)
		goto err_end;
	prnGetBottomMargin = (FnprnGetBottomMargin) ::GetProcAddress(hPrintLib, _T("prnGetBottomMargin"));
	if(!prnGetBottomMargin)
		goto err_end;
	prnSetBottomMargin = (FnprnSetBottomMargin) ::GetProcAddress(hPrintLib, _T("prnSetBottomMargin"));
	if(!prnSetBottomMargin)
		goto err_end;
	prnGetVersion = (FnprnGetVersion) ::GetProcAddress(hPrintLib, _T("prnGetVersion"));
	if(!prnGetVersion)
		goto err_end;
	prnGetSentBytes = (FnprnGetSentBytes) ::GetProcAddress(hPrintLib, _T("prnGetSentBytes"));
	if(!prnGetSentBytes)
		goto err_end;
	prnSetAbortProc = (FnprnSetAbortProc) ::GetProcAddress(hPrintLib, _T("prnSetAbortProc"));
	if(!prnSetAbortProc)
		goto err_end;
	prnSetSilentMode = (FnprnSetSilentMode) ::GetProcAddress(hPrintLib, _T("prnSetSilentMode"));
	if(!prnSetSilentMode)
		goto err_end;
	prnSetTransparentTextBgr = (FnprnSetTransparentTextBgr) ::GetProcAddress(hPrintLib, _T("prnSetTransparentTextBgr"));
	if(!prnSetTransparentTextBgr)
		goto err_end;
	prnSetTextHorAlign = (FnprnSetTextHorAlign) ::GetProcAddress(hPrintLib, _T("prnSetTextHorAlign"));
	if(!prnSetTextHorAlign)
		goto err_end;
	prnSetTextVertAlign = (FnprnSetTextVertAlign) ::GetProcAddress(hPrintLib, _T("prnSetTextVertAlign"));
	if(!prnSetTextVertAlign)
		goto err_end;
	prnSetPDFFile = (FnprnSetPDFFile) ::GetProcAddress(hPrintLib, _T("prnSetPDFFile"));
	if(!prnSetPDFFile)
		goto err_end;
	prnSetLanguage = (FnprnSetLanguage) ::GetProcAddress(hPrintLib, _T("prnSetLanguage"));
	if(!prnSetLanguage)
		goto err_end;
	prnSetPrnParam = (FnprnSetPrnParam) ::GetProcAddress(hPrintLib, _T("prnSetPrnParam"));
	if(!prnSetPrnParam)
		goto err_end;
	prnSetFontAngle = (FnprnSetFontAngle) ::GetProcAddress(hPrintLib, _T("prnSetFontAngle"));
	if(!prnSetFontAngle)
		goto err_end;
	prnGetFontAngle = (FnprnGetFontAngle) ::GetProcAddress(hPrintLib, _T("prnGetFontAngle"));
	if(!prnGetFontAngle)
		goto err_end;

	prnDrawCodaBar = (FnprnDrawCodaBar) ::GetProcAddress(hPrintLib, _T("prnDrawCodaBar"));
	if(!prnDrawCodaBar)
		goto err_end;
	prnDrawPostnet = (FnprnDrawPostnet) ::GetProcAddress(hPrintLib, _T("prnDrawPostnet"));
	if(!prnDrawPostnet)
		goto err_end;
	prnDrawCode39 = (FnprnDrawCode39) ::GetProcAddress(hPrintLib, _T("prnDrawCode39"));
	if(!prnDrawCode39)
		goto err_end;
	prnDrawCode93 = (FnprnDrawCode93) ::GetProcAddress(hPrintLib, _T("prnDrawCode93"));
	if(!prnDrawCode93)
		goto err_end;
	prnDrawEAN13 = (FnprnDrawEAN13) ::GetProcAddress(hPrintLib, _T("prnDrawEAN13"));
	if(!prnDrawEAN13)
		goto err_end;
	prnDrawEAN8 = (FnprnDrawEAN8) ::GetProcAddress(hPrintLib, _T("prnDrawEAN8"));
	if(!prnDrawEAN8)
		goto err_end;
	prnDrawUPCA = (FnprnDrawUPCA) ::GetProcAddress(hPrintLib, _T("prnDrawUPCA"));
	if(!prnDrawUPCA)
		goto err_end;
	prnDrawUPCE = (FnprnDrawUPCE) ::GetProcAddress(hPrintLib, _T("prnDrawUPCE"));
	if(!prnDrawUPCE)
		goto err_end;
	prnDraw2OF5 = (FnprnDraw2OF5) ::GetProcAddress(hPrintLib, _T("prnDraw2OF5"));
	if(!prnDraw2OF5)
		goto err_end;
	prnDrawCode128 = (FnprnDrawCode128) ::GetProcAddress(hPrintLib, _T("prnDrawCode128"));
	if(!prnDrawCode128)
		goto err_end;
	prnDrawUCC128 = (FnprnDrawUCC128) ::GetProcAddress(hPrintLib, _T("prnDrawUCC128"));
	if(!prnDrawUCC128)
		goto err_end;
	prnDrawMSI = (FnprnDrawMSI) ::GetProcAddress(hPrintLib, _T("prnDrawMSI"));
	if(!prnDrawMSI)
		goto err_end;
	prnDrawPDF417 = (FnprnDrawPDF417) ::GetProcAddress(hPrintLib, _T("prnDrawPDF417"));
	if(!prnDrawPDF417)
		goto err_end;
	prnSetBarCodeHeight = (FnprnSetBarCodeHeight) ::GetProcAddress(hPrintLib, _T("prnSetBarCodeHeight"));
	if(!prnSetBarCodeHeight)
		goto err_end;
	prnSetBarCodeScale = (FnprnSetBarCodeScale) ::GetProcAddress(hPrintLib, _T("prnSetBarCodeScale"));
	if(!prnSetBarCodeScale)
		goto err_end;
	prnSetBarCodeAngle = (FnprnSetBarCodeAngle) ::GetProcAddress(hPrintLib, _T("prnSetBarCodeAngle"));
	if(!prnSetBarCodeAngle)
		goto err_end;
	prnSetNetworkAddr = (FnprnSetNetworkAddr) ::GetProcAddress(hPrintLib, _T("prnSetNetworkAddr"));
	if(!prnSetNetworkAddr)
		goto err_end;
	prnSetPdfPassword = (FnprnSetPdfPassword) ::GetProcAddress(hPrintLib, _T("prnSetPdfPassword"));
	if(!prnSetPdfPassword)
		goto err_end;
	prnSetPdfEncodeMode = (FnprnSetPdfEncodeMode) ::GetProcAddress(hPrintLib, _T("prnSetPdfEncodeMode"));
	if(!prnSetPdfEncodeMode)
		goto err_end;
	prnSetPdfQuality = (FnprnSetPdfQuality) ::GetProcAddress(hPrintLib, _T("prnSetPdfQuality"));
	if(!prnSetPdfQuality)
		goto err_end;
	prnSetGamma = (FnprnSetGamma) ::GetProcAddress(hPrintLib, _T("prnSetGamma"));
	if(!prnSetGamma)
		goto err_end;
	prnSetPrinterDpi = (FnprnSetPrinterDpi) ::GetProcAddress(hPrintLib, _T("prnSetPrinterDpi"));
	if(!prnSetPrinterDpi)
		goto err_end;
	prnGetPrinterDpi = (FnprnGetPrinterDpi) ::GetProcAddress(hPrintLib, _T("prnGetPrinterDpi"));
	if(!prnGetPrinterDpi)
		goto err_end;
	
	gPrintLibLoaded = TRUE;

	return TRUE;

err_end:

	FreeLibrary(hPrintLib);

	hPrintLib = NULL;

	gPrintLibLoaded = FALSE;

	return FALSE;
}

void UnloadPrintLib()
{
	if(!gPrintLibLoaded)
		return;

	FreeLibrary(hPrintLib);
	
	gPrintLibLoaded = FALSE;
}

#endif //__PRINTCE_H__ 